const loader = document.querySelector('.loading');
const table = document.getElementById('table')
const region = document.getElementById('region')
const subregion = document.getElementById('subregion')
const capital = document.getElementById('capital')
const flag = document.getElementById('flag')
const button = document.getElementById('show')
const userInput = document.getElementById('country_name')
const infoToshow = document.querySelector('.show');
let name_to_find = 'Kazakhstan'


const request = (config) => {
    loader.style.display = 'flex'
    const { method, path, success, error } = config;
    const xml = new XMLHttpRequest();
    console.log(name_to_find, config.path)
    xml.addEventListener('load', () => {
        if (xml.status < 200 || xml.status > 399) {
            if (xml.status === 404) {
                error('No country with such name!');
            }
            else {
                error('bad response');
            }
            
            return;
        }
        else if (xml.status === '404') {
            console.log(xml.status);
        }
        const result = JSON.parse(xml.responseText);
        success(result)
    });
    loader.style.display = 'none'
    xml.addEventListener('error', () => {
        error('network error');
    })
    xml.addEventListener('timeout', () => {
        error('server response is late')
    })
    xml.open(method, path);
    xml.send();
}

const processResult = (result) => {
    console.log(result);
    for (country of result) {
        console.log(country);
        const stroke = document.createElement('tr')
        const cellAlfa = document.createElement('td')
        cellAlfa.innerText = country['alpha2Code']
        const cellFlag = document.createElement('td')
        const flagImg = document.createElement('img');
        flagImg.setAttribute('src', `${country.flag}`);
        flagImg.style = 'max-width: 100px; max-height: 50px'
        cellFlag.append(flagImg)
        const cellName = document.createElement('td')
        cellName.innerText = country['name']
        const cellCapital = document.createElement('td')
        cellCapital.innerText = country['capital']
        const cellPopulation = document.createElement('td')
        cellPopulation.innerText = country['population']


        stroke.append(cellAlfa, cellFlag, cellName, cellCapital, cellPopulation)
        table.append(stroke)
    }
    
    loader.style.display = 'none'
    
}

const errorHandler = (msg) => {
    alert(msg)
    console.error(msg)
}






const showInfo = () => {
    const config = {
        method: "GET",
        path: `https://restcountries.com/v2/all?fields=alpha2Code,flag,name,capital,population`,
        success: processResult,
        error: errorHandler
    }
    request(config);

}

showInfo()